#!/bin/sh
#########################################################################
# Shell-Script zum Suchen in den elektronischen Inhaltsverzeichnissen der 
# Heise-Zeitschriften per WWW-Server
# Volker Ossenkopf, Jena - 10.4.1998
#########################################################################
# Version fuer die iX 
# (bei c't muessen die Variablen auf ct und c't gesetzt werden)
SNAME='ix'; FNAME='<i>iX</i>'

# Path aller ausfuehrbaren Dateien im Script: 
# cat, expr, sed, awk, cut, cgiparse, agrep muessen gefunden werden
# Die Vermeidung ueberfluessiger Eintraege erschwert Hacks
PATH=/bin:/usr/bin:/usr/local/bin:/var/web/cgi-bin

# Directory in dem die Datenfiles ix94.dat - ix97.dat stehen
DIR=/home/www/iX/

# Gewuenschte Zugriffsart auf die gefundenen Artikel 
# entweder "file:" oder "http://www-hostname"
ACCESS='file:'

# Namen des Directories, an das das html-Directory der CD-ROMs
# gemountet oder gelinkt wird, bei ACCESS='file:' absolut
# bei ACCESS='httpd://host' relativ zu DocumentRoot
# CD-ROM 94
CDROM94=/home/www/iX/cdrom/
# CD-ROM 95
CDROM95=/home/www/iX/cdrom/
# CD-ROM 96
CDROM96=/home/www/iX/cdrom/
# CD-ROM 97
CDROM97=/home/www/iX/cdrom/

# Name des System V/R4-awk-Befehls: i.a. awk oder gawk, unter SUN-OS
# und Solaris aber nawk
AWK=awk

#########################################################################
# Ab hier sind keine Anpassungen durch den Nutzer mehr noetig !
#########################################################################

# Header produzieren
echo 'Content-type: text/html'
echo ''

# Parameter aus dem QUERY_STRING extrahieren
eval `cgiparse -form`

# Test for cgiparse and reasonable input
if [ "${FORM_cases}" != 'nicht beachten' -a "${FORM_cases}" != 'beachten' ]
then 
echo "Der Query-String konnte durch cgiparse nicht korrekt ausgewertet werden.<p>"
echo "berprfen Sie die Installation von cgiparse und die Eingabemaske."
exit 1
fi

# HTML Header
cat << !!
<HTML> <HEAD>
<TITLE>Ergebnis der ${SNAME}-Archiv-Suche</TITLE>
</HEAD> <BODY>
<p><H1 align=center>Suchergebnis: &#32;
!!

# Optionen fuer agrep entsprechend der Parameter
ENO=`echo "${FORM_fuzzy}" | sed -e 's/[^0-9]/0/g'`
PAR="-${ENO}"

case "$FORM_cases" in
nicht?beachten) PAR=$PAR' -i';;
esac

case "$FORM_words" in
ganze?Worte) PAR=$PAR' -w';;
esac

#Logische Verknuepfung auswerten, Leerzeichen entsprechend ersetzen
case "${FORM_relat}" in
String)   EXPR=`echo "${FORM_suchwort}" |sed 's/ *$//'`
          WEXPR="${FORM_suchwort}" ;;
AND)      EXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */;/g'` 
          WEXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */ \& /g'` ;;
OR)       EXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */,/g'` 
          WEXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */ \| /g'` ;;
esac

# Ausgabe des Suchwortes im Kopf
echo "${WEXPR} </h1>"

# Anzahlbegrenzung ermitteln
if ANZ=`expr "${FORM_anzahl}" - 0 2>/dev/null`; then ANZ=$ANZ; else ANZ=1000; fi

# Sortierrichtung
case "${FORM_richtung}" in
aufsteigend) SPAR='-b' ;;
absteigend) SPAR='-r' ;;
esac

# Spaltennummern finden fuer Werte die per feld gegeben wurden
# Datenformat der dat-Dateien der CDROMs (Trenner = '|')
# 1: Titel, 2: Untertitel, 3: Zeitschrift, 4: Jahr, 5: Monat, 6: Seite
# 7: Autor, 8: Erfassungsdatum, 9: ISBN, 10: Filename, 11: Schlagworte
FIELDS=' -f '
if echo "${FORM_feld}" |fgrep -e Titel >/dev/null; then FIELDS=${FIELDS}'1,' ; fi
if echo "${FORM_feld}" |fgrep -e Untertitel >/dev/null; then FIELDS=${FIELDS}'2,' ; fi
if echo "${FORM_feld}" |fgrep -e Schlagworte >/dev/null; then FIELDS=${FIELDS}'11,' ; fi
if echo "${FORM_feld}" |fgrep -e Autor >/dev/null; then FIELDS=${FIELDS}'7,' ; fi
if echo "${FORM_feld}" |fgrep -e Jahr >/dev/null; then FIELDS=${FIELDS}'4,' ; fi
if echo "${FORM_feld}" |fgrep -e Monat >/dev/null; then FIELDS=${FIELDS}'5,' ; fi
if echo "${FORM_feld}" |fgrep -e Seite >/dev/null; then FIELDS=${FIELDS}'6,' ; fi
FIELDS=${FIELDS}'8'

# Monate numerisch machen, Jahre aus Parametern bestimmen
# Sicherstellen, dass kein Hack ueber $DAT moeglich wird
M1=`echo "${FORM_monat1}" | sed -e 's/[^0-9]/0/g'`
M2=`echo "${FORM_monat2}" | sed -e 's/[^0-9]/0/g'`
if J1=`expr "${FORM_jahr1}" - 1900`; then J0=$J1;
else echo "${FORM_jahr1}"' ist nichtnumerisch </body></html>'; exit ; fi
if J2=`expr "${FORM_jahr2}" - 1900`; then echo '<hr>';
else echo "${FORM_jahr2}"' ist nichtnumerisch </body></html>'; exit ; fi

# Schleife fuer Jahre
while test $J1 -le $J2 
do 
DAT=${SNAME}${J1}'.dat' 

# Directories auswaehlen
case $J1 in
94) CDROM=${CDROM94} ;;
95) CDROM=${CDROM95}${J1}/ ;;
96) CDROM=${CDROM96}${J1}/ ;;
97) CDROM=${CDROM97}${J1}/ ;;
esac

# Monatsbedingung fuer das jeweilige Jahr formulieren
if test $J0 -eq $J2; then COND='$5 >= '$M1' && $5 <= '$M2; 
elif test $J1 -eq $J0; then COND='$5 >= '$M1; 
elif test $J1 -eq $J2; then COND='$5 <= '$M2;
else COND='';
fi

# Zweistufige Reduktion mit awk und sed
#     - Monatsbegrenzung beruecksichtigen
#     - Felder ausschneiden, 
#     - mit agrep Suchworte finden,
#     - Zeilennummern an sed uebergeben 
#     - Pfad mit uebergeben -> alle Eintragsnummern wachsen um 1
# ( agrep mit -n macht oft Mist -> Zeilennummern vorher mit nl erzeugen )
$AWK -F"|" "${COND}"' {printf("'${CDROM}'|%s\n",$0) } ' ${DIR}${DAT} 2>/dev/null |\
sed -n `$AWK -F"|" "${COND}"' {print} ' ${DIR}${DAT} 2>/dev/null |\
cut -d"|" $FIELDS |\
nl -ba -p | agrep $PAR "${EXPR}" 2>/dev/null |\
sed -e 's/^ */-e /' -e 's/\	.*$/p /'` 2>/dev/null 
# sed -e 's/^ */-e /' -e 's/\	.*$/p /'|head -n 99 ` 2>/dev/null
# DEC und HP sed koennen nur 99 Kommandos. Falls dieses verwendet werden
# soll, muss die Zeile mit 'head -n 99' statt der vorhergehenden benutzt
# werden.

J1=`expr $J1 + 1`
done |\

# Ende der Jahresschleife
# Nachverarbeitung des gesamten Ergebnisstromes
#     - Sortieren,
#     - Uebergabebegrenzung beruecksichtigen,
#     - Daten fuer die Ausgabe formatieren
sort "${SPAR}" -t'|' +4 -7 |\
$AWK -F"|" 'NR <= '"${ANZ}"' {printf("<h3>%s</h3>", $2);
	    printf("<h4>%s</h4>", $3);
	    nn = split($8, NOM, "/");
	    if ( NOM[1] != "" ) printf("%s, <kbd>%s</kbd><p>\n", NOM[1],NOM[2]);
	    else printf("\n");
	    gsub("'${SNAME}'","'${FNAME}'",$4);
	    printf("<A HREF=\"'${ACCESS}'%s%02d/%03d/%s\">",$1,$6,$7,$11);
	    printf("%s %s, Heft %d, Seite %d</A><P>\n", $4, $5, $6, $7);
	    printf("<i> %s</i>\n",$12);
	    printf("<HR>\n") } 
	   END { if ( NR == 0 ) { printf("<p><b>Keine Eintr&auml;ge gefunden.</b><p><hr>\n");
				  printf("<h2 align=center>Suche nach &auml;hnlichen Begriffen:</h2><hr><p>\n");
				  exit 1 }
		printf("<h2 align=center>Insgesamt %d Artikel in '${FNAME}' '$M1'/'$J1' - '$M2'/'$J2' gefunden.</h2><hr>\n",NR) } 
	   '

# Weitere Durchlaeufe mit toleranteren Kriterien, wenn nichts gefunden wurde
FOUND=$?
while [ '(' $FOUND -ne 0 ')' -a  '(' $ENO -le 3 ')' ] 
do
PAR="-i -$ENO"
ENO=`expr "${ENO}" + 1`

# Die gesamte Prozedur von oben wird hier mit relaxten Parametern wiederholt
J1=`expr "${FORM_jahr1}" - 1900`
while test $J1 -le $J2 
do 
DAT=${SNAME}${J1}'.dat' 
case $J1 in
94) CDROM=${CDROM94} ;;
95) CDROM=${CDROM95}${J1}/ ;;
96) CDROM=${CDROM96}${J1}/ ;;
97) CDROM=${CDROM97}${J1}/ ;;
esac
if test $J0 -eq $J2; then COND='$5 >= '$M1' && $5 <= '$M2; 
elif test $J1 -eq $J0; then COND='$5 >= '$M1; 
elif test $J1 -eq $J2; then COND='$5 <= '$M2;
else COND='';
fi
$AWK -F"|" "${COND}"' {printf("'${CDROM}'|%s\n",$0) } ' ${DIR}${DAT} 2>/dev/null |\
sed -n `$AWK -F"|" "${COND}"' {print} ' ${DIR}${DAT} 2>/dev/null |\
cut -d"|" $FIELDS |\
nl -ba -p | agrep $PAR "${EXPR}" 2>/dev/null |\
sed -e 's/^ */-e /' -e 's/\	.*$/p /'` 2>/dev/null 
# sed -e 's/^ */-e /' -e 's/\	.*$/p /'|head -n 99 ` 2>/dev/null
J1=`expr $J1 + 1`
done |\
sort "${SPAR}" -t'|' +4 -7 |\
$AWK -F"|" 'NR <= '"${ANZ}"' {printf("<h3>%s</h3>", $2);
	    printf("<h4>%s</h4>", $3);
	    nn = split($8, NOM, "/");
	    if ( NOM[1] != "" ) printf("%s, <kbd>%s</kbd><p>\n", NOM[1],NOM[2]);
	    else printf("\n");
	    gsub("'${SNAME}'","'${FNAME}'",$4);
	    printf("<A HREF=\"'${ACCESS}'%s%02d/%03d/%s\">",$1,$6,$7,$11);
	    printf("%s %s, Heft %d, Seite %d</A><P>\n", $4, $5, $6, $7);
	    printf("<i> %s</i>\n",$12);
	    printf("<HR>\n") } 
	   END { if ( NR == 0 ) exit 1 
		 printf("<h2 align=center>Insgesamt %d Artikel in '${FNAME}' '$M1'/'$J1' - '$M2'/'$J2' gefunden.</h2><hr>\n",NR) } 
	   '
FOUND=$?
done

# Schlussausgabe, falls keine Eintraege gefunden wurden
if [ $FOUND -ne 0 ]
then
echo "<b>Keine Eintrge gefunden</b><p><hr>"
echo "<h2 align=center>Keine Fundstellen in ${FNAME} ${M1}/${J1} - ${M2}/${J2}.</h2><hr>"
fi

# Kontrollausgabe der Input-Parameter
echo "<strong>Benutzte Parameter:</strong> Gro/Kleinschreibung ${FORM_cases}, bereinstimmung: ${FORM_words}, ${FORM_fuzzy} Fehler, Wortverknpfung: ${FORM_relat},"
echo "Suchfelder: ${FORM_feld}, Fundstellenausgabe: ${FORM_anzahl}, ${FORM_richtung} sortiert.<hr>"

echo "</BODY></HTML>"
# Das wars schon.

