#!/bin/sh
#########################################################################
# Shell-Script zur Volltextsuche in einzelnen Heften der CD-ROM-Versionen
# der Zeitschriften des Heise-Verlages
# Volker Ossenkopf, Jena - 10.4.1998
#########################################################################
# Version fuer die iX
# (bei c't muessen die Variablen auf "ct" und "c't" gesetzt werden)
SNAME='ix'; FNAME='<i>iX</i>'

# Path aller ausfuehrbaren Dateien im Script: 
# sed, awk, cgiparse, agrep und eventuell glimpse muessen gefunden werden
PATH=/bin:/usr/bin:/usr/local/bin:/var/web/cgi-bin

# Gewuenschte Zugriffsart auf die gefundenen Artikel 
# entweder "file:" oder "http://www-hostname"
ACCESS='file:'

# Namen des Directories, an das das html-Directory der CD-ROMs
# gemountet oder gelinkt wird
# DIRLOC?? = Lokales Directory (voller Name)
#	     Wenn mit einem glimpse-Index gearbeitet wird muss dieser
#	     die vollen Pfadnamen enthalten.
# DIRWWW?? = Verzeichnisname relativ zu DocumentRoot
#	     Bei ACCESS='file:' sollte das identisch zu DIRLOC? sein
# DIRIDX?? = Lokales Directory das den zugehoerigen glimpse-Index enthaelt
#	     Wenn hier kein Index gefunden wird, wird nur agrep benutzt.
# Alle Verzeichnisnamen mit angehaengtem '/' schreiben.

# CD-ROM 94
DIRLOC94=/home/www/iX/cdrom/
DIRWWW94=/home/www/iX/cdrom/
DIRIDX94=/home/www/iX/glimpse94/
# CD-ROM 95
DIRLOC95=/home/www/iX/cdrom/
DIRWWW95=/home/www/iX/cdrom/
DIRIDX95=/home/www/iX/glimpse95/
# CD-ROM 96
DIRLOC96=/home/www/iX/cdrom/
DIRWWW96=/home/www/iX/cdrom/
DIRIDX96=/home/www/iX/glimpse96/
# CD-ROM 97
DIRLOC97=/home/www/iX/cdrom/
DIRWWW97=/home/www/iX/cdrom/
DIRIDX97=/home/www/iX/glimpse97/

# Name des System V/R4-awk-Befehls: i.a. awk oder gawk, unter SUN-OS
# und Solaris aber nawk
AWK=awk

#########################################################################
# Ab hier sind keine Anpassungen durch den Nutzer mehr noetig !
#########################################################################

# Header produzieren
echo 'Content-type: text/html'
echo ''

# Parameter aus dem QUERY_STRING extrahieren
eval `cgiparse -form`

# Test for cgiparse and reasonable input
if [ "${FORM_cases}" != 'nicht beachten' -a "${FORM_cases}" != 'beachten' ]
then 
echo "Der Query-String konnte durch cgiparse nicht korrekt ausgewertet werden.<p>"
echo "berprfen Sie die Installation von cgiparse und die Eingabemaske."
exit 1
fi

# HTML-Header
cat << !!
<HTML> <HEAD>
<TITLE>Ergebnis der ${SNAME}-Volltextrecherche</TITLE>
</HEAD> <BODY>
<H1 align=center>Suchergebnis: &#32;
!!

# Optionen fuer agrep entsprechend der Parameter
# Fuzzy-Variable entschaerfen
case "$FORM_fuzzy" in
0) FUZ=0; PAR='';;
*) FUZ=1; PAR='-'`echo "${FORM_fuzzy}" |sed -e 's/[^1-9]/0/g'`;;
esac
MINPAR='-i '$PAR

OTH=0
case "$FORM_cases" in
nicht?beachten) OTH=${OTH}1 ; PAR=$PAR' -i';;
esac

case "$FORM_words" in
ganze?Worte) OTH=${OTH}1 ; PAR=$PAR' -w';;
esac

#Logische Verknuepfung auswerten, Leerzeichen entsprechend ersetzen
case "${FORM_relat}" in
String)   EXPR=`echo "${FORM_suchwort}" |sed 's/ *$//'`
          WEXPR="${FORM_suchwort}" ;;
AND)      EXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */;/g'`
          WEXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */ \& /g'` ;; 
OR)       EXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */,/g'`
          WEXPR=`echo "${FORM_suchwort}" |sed -e 's/ *$//' -e 's/  */ \| /g'` ;;
esac
# Eine Boolsche Verknuepfung entspricht einer zusaetzlichen Option
if echo "${EXPR}" |grep -q -e '[,;]' 2>/dev/null
then OTH=${OTH}1
fi
# Suchstring fuer zweite Stufe der Reduktionssuche
MINEXP='pre\>,'`echo "${EXPR}" |  sed -e 's/;/,/g' -e 's/^\(.\{22\}\).*/\1/'`

# In der Kombination von fehlertoleranter Suche mit irgendeiner anderen
# Option macht agrep schwere Fehler bei der Delimiter-Behandlung, bei
# der Zeilenzaehlung mit -n und bei der Dateinamenausgabe mit -l !
# Diese werden 1:1 an glimpse weitergegeben. Deshalb muss in diesem Fall
# der Delimiter < durch \< ersetzt werden. Weiterhin wird -l hier
# vermieden indem es durch -c mit anschliessendem sed ersetzt wird.
if test `expr "${FUZ}" \* "${OTH}"` -ge 1 
then PAR=$PAR' -d \<'
else PAR=$PAR' -d <'
fi

# Ausgabe des Suchwortes im Kopf
echo "${WEXPR} </h1><hr>"

# Anzahlbegrenzung ermitteln
if ANZ=`expr "${FORM_anzahl}" - 0 2>/dev/null `; then ANZ=$ANZ; else ANZ=1000; fi

# Jahre aus Parametern bestimmen, Directories auswaehlen
J1=`expr "${FORM_jahr}" - 1900`
case $J1 in
94) DIRLOC=${DIRLOC94}; DIRWWW=${DIRWWW94}; DIRIDX=${DIRIDX94} ;;
95) DIRLOC=${DIRLOC95}${J1}/; DIRWWW=${DIRWWW95}${J1}/; DIRIDX=${DIRIDX95} ;;
96) DIRLOC=${DIRLOC96}${J1}/; DIRWWW=${DIRWWW96}${J1}/; DIRIDX=${DIRIDX96} ;;
*) DIRLOC=${DIRLOC97}${J1}/; DIRWWW=${DIRWWW97}${J1}/; DIRIDX=${DIRIDX97} ;;
esac

# Monate numerisch machen und sicher machen
MONAT=`echo '0'"${FORM_monat}" | sed -e 's/[^0-9,]//g' -e 's/,/,0/g' -e 's/0\([1-9][0-9]\)/\1/g'`

# Folge von Suchmustern fuer die glimpse-Dateinamen konstruieren
TREE=`echo ${MONAT} | sed -e 's:[01][0-9]:'${DIRLOC}'&/:g' `

# Heft-Directory scannen - Liste von Dateinamen erstellen.
# Arbeit mit glimpse. Falls kein glimpse-Index vorhanden ist,
# wird agrep auf alle Artikel-Dateien angewendet
if test -r ${DIRIDX}.glimpse_index 
then
FPAR='-F '"${TREE}"

# Da das F-Feld von glimpse nur 256 Zeichen enthalten darf, sollte 
# ein kurzer Unterscheidungspfad gewaehlt werden -> groessten gemeinsamen
# Pfad abtrennen (Damit kann ein gemeinsamer Index benutzt werden).
COMN=`echo ${DIRLOC} |\
$AWK -F'/' '{ MAX=NF-2; for (i=2;i<=MAX;i++) printf("/%s",$i); printf("\n") }'`
FPAR=`echo $FPAR | sed -e 's:,'${COMN}':,:g'`

FULLLIST=`glimpse -c -y $PAR $FPAR -H $DIRIDX "${EXPR}" 2>/dev/null | sed 's/: .*$//'`
else
TREE=`echo "${TREE}" |sed -e 's/,/ /g' -e 's:/[01][0-9]/:&*/art*.htm:g'`
FULLLIST=`agrep -c $PAR "${EXPR}" $TREE 2>/dev/null |\
sed -e 's/^.*: 0$//' -e 's/: .*$//' `
fi

# Anzahl ermitteln/begrenzen
TOT=`echo ${FULLLIST} | wc -w`
FULLLIST=`echo $FULLLIST |cut -d ' ' -f 1-${ANZ}`

# Titel und Textstellen heraussuchen
# Fuer Titelzeile und Suchwort sind zwei Durchgaenge noetig, um im
# fehlertoleranten Fall die Worterkennung nicht durch einen Boolschen
# Ausdruck zu opfern, einzelne Hervorhebungen werden ignoriert.
for i in $FULLLIST
do 
echo '{{h3}}'$i ;
agrep -d '<' -i '\<title\>' $i 2>/dev/null ; echo '{{p}}'
sed -e 's/<\/*[bBiI]>//g' $i |agrep $PAR "${EXPR}" 2>/dev/null |\
agrep $MINPAR -d '$$' "${MINEXP}" 2>/dev/null ;
echo '' ; echo '{{p}}{{hr}}'
done |\

# Nachbearbeitung mit sed und awk
# Doppelbenutzung ist ineffektiv aber einfachste Loesung (spaeter verbessern)
sed -e 's/<[Tt][Ii][Tt][Ll][Ee]>/\
{{h2}}/g'  -e 's/<[Pp][Rr][Ee]>/\
{{pre}}/g' -e 's/<[^>]*>/\
{{p}}/g' -e 's/{{/</g' -e 's/}}/>/g' |\

# Manche awk Versionen haben eine Feldzahlbegrenzung.
# Bei Problemen kann diese durch einen anderen Delimiter umgangen werden.
$AWK  '	BEGIN  { LAST="" }
	/</    { LLAST="</"substr($0,2,index($0,">")-1);
		 $0=LAST$0;
		 LAST=LLAST }
	/<h3>/ { FNAME=$0;
		 nn=gsub("<h3>'$DIRLOC'","<h3><a href=\"'${ACCESS}${DIRWWW}'",$0);
		 nn=gsub("^.*<h3>'$DIRSUB'","",FNAME);
		 nn=split(FNAME,NUMB,"/");
		 printf("%s\">'${FNAME}' '${J1}', Heft %d, Seite %d </a>", $0,NUMB[nn-2],NUMB[nn-1]);
		 nn=gsub(".*","",$0) }
              { print } '

MONAT=`echo $MONAT | sed -e 's/^0//' -e 's/,0/,/g'`
echo "<h2 align=center>Begriff in ${TOT} Artikeln der ${FNAME} ${MONAT}/${J1} gefunden. </h2>"
echo '<p><hr>'

# Kontrollausgabe der Input-Parameter
echo "<strong>Benutzte Parameter:</strong> Gro/Kleinschreibung ${FORM_cases}, bereinstimmung: ${FORM_words}, ${FORM_fuzzy} Fehler, Wortverknpfung: ${FORM_relat},"
echo "Fundstellenausgabe: ${FORM_anzahl}.<hr><p>"

echo "</BODY></HTML>"
# Das wars schon.

